<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_10</title>
</head>
<body>
    <h1>Capitulo 10</h1>
    <a>Ejercicio 10</a>

    <script>

        class Node {
            constructor() {
                this.data = 0;
                this.left = null;
                this.right = null;
                this.leftSize = 0;
            }
        }
 
        const newNode = (data) => {
            
            let temp = new Node();
            temp.data = data;
            temp.left = null;
            temp.right = null;
            temp.leftSize = 0;
            return temp;
        }   
 
        const insertar = (root, data) => {
            if (root == null) {
                return newNode(data);
            }
 
            if (data <= root.data) {
                root.left = insertar(root.left, data);
                root.leftSize++;
            }
            else {
                root.right = insertar(root.right, data);
            }
 
            return root;
        }
 
        const clasificacion = (root, x) => {

            if (root.data == x) {
                return root.leftSize;
            }
 
            if (x < root.data) {
                if (root.left == null)
                    return -1;
                else 
                    return clasificacion(root.left, x);
            } else {
                if (root.right == null)
                    return -1;
                else {
                    var rightSize = clasificacion(root.right, x);
                    if(rightSize == -1) return -1;
                    return root.leftSize + 1 + rightSize;
                }
            }
        }
 

        var arr = [5, 1, 4, 4, 5, 9, 7, 13, 3];
        var n = arr.length;
        var x = 4;
        var root = null;
        for (var i = 0; i < n; i++) {
            root = insertar(root, arr[i]);
        }
        console.log(`clasificacion de "${x}" esta en la clasificación: "${clasificacion(root, x)}"`);
        x = 13;
        console.log(`clasificacion de "${x}" esta en la clasificación: "${clasificacion(root, x)}"`);
        x = 8;
        console.log(`clasificacion de "${x}" esta en la clasificación: "${clasificacion(root, x)}"`);
        
</script>
    
</body>
</html>